\ 2020-06-23---Tue---22:33
\ AE - Gforth

\ Other examples

\ Naming of pins
( * WIRING * )
9 constant BUZZ
3 constant FLASHER
13 constant LED

\ Sets of pins brute force method
\ : test-beep ( -- )  
\     BUZZ out  FLASHER out  LED out  
\     LED high  1000 ms  FLASHER high 1000 ms  BUZZ high  1000 ms
\     BUZZ low  1000 ms  FLASHER low  1000 ms  LED low 
\     ;

\ Sets of pins - more elegant (loops)
: 3dup  ( a b c -- a b c a b c )  >r 2dup ( a b a b ) r@ swap >r ( a b a c ) swap r> r> ;
: 3rev ( a b c -- c b a ) swap rot ;
: test2-beep ( -- )
    LED FLASHER BuZZ  
    3dup 3 0 do out loop 
    3dup 3 0 do high 1000 ms loop
    3 0 do low 1000 ms loop
    ;

\ Add a batch n-set and n-mode or n-xcall command in the chip for efficient timing.


: adv-help  ( -- ) 
    cr ." 3-instruction Forth for Atmel328/Arduino Nano"
    cr ." Assad Ebrahim (c)2020 -- All Rights Reserved"
    cr ." http://www.mathscitech.org/articles"
    cr ." --------------------------------------------"
    cr ." Atmel328 with 3iForth recognizes xstore, xdrop, x_s, xcall."
    cr ." This file provides words to access functionality on the chip"
    cr ."     from your PC over a serial connection."
    
    cr ."  1.  6 open-com "
    cr ."  2.  1  13 pinmode       In general:  pinMode ( mode pin --  )"
    cr ."  3.  1  13 pinset        In general:  pinset  ( level pin -- )   (also called digitalWrite() in Arduino C)."
    cr ."  4.  0  13 pinset        "
    cr ."  5.  close-com             "
    cr ." --------------------------------------------"
    cr ." To expose more  Atmel328 funtionality, modify NiForth.avr and update this file."
    cr
    cr
;
